
<!-- Warning: This file has been autogenerated by tools/makedoc.py. Manual edits will be overwritten. -->
<html>
    <head>
        <title>freesmartphone.org GSM SIM Interface</title>
        <link rel="stylesheet" type="text/css" href="http://git.freesmartphone.org/?p=specs.git;a=blob_plain;f=html/style.css;hb=HEAD" />
    </head>
    <body>
    <div class="topbox">freesmartphone.org Framework DBus Interface Specification</div>


<h1>org.freesmartphone.GSM.SIM</h1><h2>Description</h2>
<p>The SIM interface is used to access the Subscriber Identification Module (SIM)  plugged as a card into a GSM device. Use it to authenticate yourself  against the GSM network and read/store data from/to the embedded SIM card memory.  Support for accessing the on-card phonebooks and messagebook is also provided.</p>
<h2>Namespace</h2>
<p><tt>org.freesmartphone.GSM.SIM</tt></p>
<h2>Methods</h2><ul>
<li><a href="#GetAuthStatus">GetAuthStatus</a></li>
<li><a href="#SendAuthCode">SendAuthCode</a></li>
<li><a href="#GetUnlockCounters">GetUnlockCounters</a></li>
<li><a href="#Unlock">Unlock</a></li>
<li><a href="#ChangeAuthCode">ChangeAuthCode</a></li>
<li><a href="#SetAuthCodeRequired">SetAuthCodeRequired</a></li>
<li><a href="#GetAuthCodeRequired">GetAuthCodeRequired</a></li>
<li><a href="#GetSimInfo">GetSimInfo</a></li>
<li><a href="#SendGenericSimCommand">SendGenericSimCommand</a></li>
<li><a href="#SendRestrictedSimCommand">SendRestrictedSimCommand</a></li>
<li><a href="#GetHomeZoneParameters">GetHomeZoneParameters</a></li>
<li><a href="#GetPhonebookInfo">GetPhonebookInfo</a></li>
<li><a href="#DeleteEntry">DeleteEntry</a></li>
<li><a href="#StoreEntry">StoreEntry</a></li>
<li><a href="#RetrievePhonebook">RetrievePhonebook</a></li>
<li><a href="#GetServiceCenterNumber">GetServiceCenterNumber</a></li>
<li><a href="#SetServiceCenterNumber">SetServiceCenterNumber</a></li>
<li><a href="#DeleteMessage">DeleteMessage</a></li>
<li><a href="#StoreMessage">StoreMessage</a></li>
<li><a href="#SendStoredMessage">SendStoredMessage</a></li>
<li><a href="#RetrieveMessage">RetrieveMessage</a></li>
</ul>
<h2>Signals</h2><ul>
<li><a href="#AuthStatus">AuthStatus</a></li>
<li><a href="#IncomingMessage">IncomingMessage</a></li>
</ul>
<h2>Properties</h2><i>None</i>
<h2>Errors</h2><i>None</i>
<h1>Methods</h1><h3><a name="GetAuthStatus">GetAuthStatus</a> ( ) &rarr; s</h3>
<p><i>Description:</i> Retrieve the authentication status for the SIM card. </p><h4>Returns</h4><i>s: status</i><p>The authentication status for the SIM card. Values to expect:  <ul>  <li>"UNKNOWN" = unknown (possibly due to SIM communication error or SIM not inserted)</li>  <li>"READY" = not waiting for any PIN or PUK,</li>  <li>"SIM PIN" = waiting for SIM PIN to be given,</li>  <li>"SIM PUK" = waiting for SIM PUK to be given,</li>  <li>"SIM PIN2" = waiting for SIM PIN 2 to be given,</li>  <li>"SIM PUK2" = waiting for SIM PUK 2 to be given.</li>  </ul> </p>
<h3><a name="SendAuthCode">SendAuthCode</a> ( s )</h3>
<p><i>Description:</i> Send authentication code (PIN) for the SIM card. </p><h4>Parameters</h4><i>s: pin</i><p>The authentication code. </p>
<h3><a name="GetUnlockCounters">GetUnlockCounters</a> ( ) &rarr; a{sv}</h3>
<p><i>Description:</i> Retrieve the unlock counters for the SIM card. </p><p><div class="rationale"><p>This is outside the GSM standard and only supported on some devices. </p></div></p><h4>Returns</h4><i>a{sv}: counters</i><p>The unlock counters for the SIM card. </p>
<h3><a name="Unlock">Unlock</a> ( ss )</h3>
<p><i>Description:</i> Send unlock code (PUK) and new authentication code (PIN). </p><h4>Parameters</h4><i>s: puk</i><p>The unlock code. </p><i>s: new_pin</i><p>The new authentication code. </p>
<h3><a name="ChangeAuthCode">ChangeAuthCode</a> ( ss )</h3>
<p><i>Description:</i> Change the authentication code. </p><h4>Parameters</h4><i>s: old_pin</i><p>The old authentication code. </p><i>s: new_pin</i><p>The new authentication code. </p>
<h3><a name="SetAuthCodeRequired">SetAuthCodeRequired</a> ( bs )</h3>
<p><i>Description:</i> Enable or disable checking for the SIM card authentification on startup. </p><h4>Parameters</h4><i>b: check</i><p>True, to turn SIM card authentification on. False, to turn it off. </p><i>s: pin</i><p>A valid authentication code. </p>
<h3><a name="GetAuthCodeRequired">GetAuthCodeRequired</a> ( ) &rarr; b</h3>
<p><i>Description:</i> Retrieve whether the SIM card checks for authentification on startup. </p><h4>Returns</h4><i>b: check</i><p>True, if SIM card authentification is turned on. False, otherwise. </p>
<h3><a name="GetSimInfo">GetSimInfo</a> ( ) &rarr; a{sv}</h3>
<p><i>Description:</i> Get information stored on the SIM card. </p><h4>Returns</h4><i>a{sv}: info</i><p>Information about the SIM card. Possible tuples are:  <ul>  <li>("imsi", string) = The unique subscriber identification stored on your SIM.</li>  <li>("issuer", string) = The unique subscriber identification stored on your SIM.</li>  <li>("phonebooks", space-separated string) = The phonebooks stored on this SIM.  Expected values are "contacts", "dialed", "received", "own", "missed", "emergency".  Other phonebooks are named included with their native code and prefixed "aux:".</li>  <li>("slots") = The capacity of the messagebook</li>  <li>("messages") = The messages in the messagebook</li>  </ul> </p>
<h3><a name="SendGenericSimCommand">SendGenericSimCommand</a> ( s ) &rarr; s</h3>
<p><i>Description:</i> Send a generic SIM command to the SIM card. </p><h4>Parameters</h4><i>s: command</i><p>The command to send, encoded as described in GSM 11.11. </p><h4>Returns</h4><i>s: result</i><p>The result of the command, encoded as described in GSM 11.11. </p>
<h3><a name="SendRestrictedSimCommand">SendRestrictedSimCommand</a> ( iiiiis ) &rarr; s</h3>
<p><i>Description:</i> Send a restricted SIM command to the SIM card. </p><h4>Parameters</h4><i>i: command</i><p>The command to send. Valid values are:  <ul>  <li>176 = READ BINARY,</li>  <li>178 = READ RECORD,</li>  <li>192 = GET RESPONSE,</li>  <li>214 = UPDATE BINARY,</li>  <li>220 = UPDATE RECORD,</li>  <li>242 = STATUS.</li>  </ul> </p><i>i: fileid</i><p>The identifier of an elementary datafile on SIM. Mandatory for every command except STATUS. </p><i>i: p1</i><p>Parameter 1 passed to the SIM. Mandatory for every command except STATUS and GET RESPONSE. </p><i>i: p2</i><p>Parameter 1 passed to the SIM. Mandatory for every command except STATUS and GET RESPONSE. </p><i>i: p3</i><p>Parameter 1 passed to the SIM. Mandatory for every command except STATUS and GET RESPONSE. </p><i>s: data</i><p>The command data to the SIM, encoded as described in GSM 11.11. </p><h4>Returns</h4><i>s: result</i><p>The result of the command, encoded as described in GSM 11.11. </p>
<h3><a name="GetHomeZoneParameters">GetHomeZoneParameters</a> ( ) &rarr; a(siii)</h3>
<p><i>Description:</i> Retrieve the homezones coordinates, if stored on the SIM. </p><h4>Returns</h4><i>a(siii): homezones</i><p>An array containing up to four homezones in Gauss-Krueger coordinates. The array contains of four-tuples with the following format:  <ol>  <li>(name:string), the name of the zone,</li>  <li>(x:int), the X value of the zone center in Gauss-Krueger format,</li>  <li>(y:int), the Y value of the zone center in Gauss-Krueger format,</li>  <li>(r:radius), the R*R value of the zone dimension in meters.</li>  </ol> </p>
<h3><a name="GetPhonebookInfo">GetPhonebookInfo</a> ( s ) &rarr; iii</h3>
<p><i>Description:</i> Request information about a phonebook. </p><h4>Parameters</h4><i>s: category</i><p>The phonebook storage category.  See <a href="http://docs.freesmartphone.org/org.freesmartphone.GSM.SIM.html#GetSimInfo">GetSimInfo</a> for valid categories. </p><h4>Returns</h4><i>i: slots</i><p>Capacity of the phonebook. </p><i>i: numberlength</i><p>Maximum length for the phone number. </p><i>i: namelength</i><p>Maximum length for the associated name. </p>
<h3><a name="DeleteEntry">DeleteEntry</a> ( si )</h3>
<p><i>Description:</i> Delete an entry in the SIM phonebook. </p><h4>Parameters</h4><i>s: category</i><p>The phonebook storage category. See <a href="http://docs.freesmartphone.org/org.freesmartphone.GSM.SIM.html#GetSimInfo">GetSimInfo</a>  for a list of valid categories. </p><i>i: index</i><p>Index of entry to delete. </p>
<h3><a name="StoreEntry">StoreEntry</a> ( siss )</h3>
<p><i>Description:</i> Store an entry in the SIM phonebook. </p><h4>Parameters</h4><i>s: category</i><p>The phonebook storage category. See <a href="http://docs.freesmartphone.org/org.freesmartphone.GSM.SIM.html#GetSimInfo">GetSimInfo</a>  for a list of valid categories. </p><i>i: index</i><p>The index of the entry to store. </p><i>s: name</i><p>The name corresponding to the number. </p><i>s: number</i><p>The number corresponding to the name. </p>
<h3><a name="RetrievePhonebook">RetrievePhonebook</a> ( sii ) &rarr; a(iss)</h3>
<p><i>Description:</i> Retrieve (parts of) a SIM phonebook. </p><h4>Parameters</h4><i>s: category</i><p>The phonebook storage category.  Use <a href="http://docs.freesmartphone.org/org.freesmartphone.GSM.SIM.html#GetSimInfo">GetSimInfo</a> to gather the list of valid categories. </p><i>i: mindex</i><p>The minimum index of the entry to retrieve. </p><i>i: maxdex</i><p>The maximum index of entries to receive. </p><h4>Returns</h4><i>a(iss): entries</i><p>The phonebook entries. This is an array of three-tuples. Every entry has the following structure:  <ul>  <li>(int:index) = storage index.</li>  <li>(string:name) = name.</li>  <li>(string:number) = number.</li>  </ul> </p>
<h3><a name="GetServiceCenterNumber">GetServiceCenterNumber</a> ( ) &rarr; s</h3>
<p><i>Description:</i> Retrieve phone number of SMS Center. </p><h4>Returns</h4><i>s: number</i><p>The SMS Center Number. </p>
<h3><a name="SetServiceCenterNumber">SetServiceCenterNumber</a> ( s )</h3>
<p><i>Description:</i> Set phone number of SMS Center. </p><h4>Parameters</h4><i>s: number</i><p>The SMS Center Number. </p>
<h3><a name="DeleteMessage">DeleteMessage</a> ( i )</h3>
<p><i>Description:</i> Delete a message in the SIM messagebook. </p><h4>Parameters</h4><i>i: index</i><p>The storage index of the message to delete. </p>
<h3><a name="StoreMessage">StoreMessage</a> ( ssa{sv} ) &rarr; i</h3>
<p><i>Description:</i> Store a message in the SIM messagebook. </p><h4>Parameters</h4><i>s: recipient_number</i><p>The number of the recipient. </p><i>s: contents</i><p>The contents of the message. </p><i>a{sv}: properties</i><p>For a list of valid properties see <a href="http://docs.freesmartphone.org/org.freesmartphone.GSM.SMS.html#SendMessage">SendMessage</a> </p><h4>Returns</h4><i>i: index</i><p>The index of the new message. </p>
<h3><a name="SendStoredMessage">SendStoredMessage</a> ( i ) &rarr; is</h3>
<p><i>Description:</i> Sends a message stored in the SIM messagebook. </p><h4>Parameters</h4><i>i: index</i><p>The index of the message. </p><h4>Returns</h4><i>i: transaction_index</i><p>The given transaction index for this message. </p><i>s: timestamp</i><p>The timestamp this message was received by the SMSC </p>
<h3><a name="RetrieveMessage">RetrieveMessage</a> ( i ) &rarr; sssa{sv}</h3>
<p><i>Description:</i> Retrieve a message from the SIM messagebook. </p><h4>Parameters</h4><i>i: index</i><p>The index of the message to retrieve. </p><h4>Returns</h4><i>s: status</i><p>The category the message is in, one of ("read", "sent", "unread", "unsent"). </p><i>s: sender_number</i><p>The number of the sender. </p><i>s: contents</i><p>The contents of the message. </p><i>a{sv}: properties</i><p>Additional properties (TBD). </p>
<h1>Signals</h1><h3><h3><a name="AuthStatus">AuthStatus</a> ( s )</h3><p><i>Description:</i> Sent, when the authentication status for the SIM card changes. </p><h4>Parameters</h4><i>s: status</i><p>The authentication status for the SIM card. See <a href="http://docs.freesmartphone.org/org.freesmartphone.GSM.SIM.html#GetAuthStatus">GetAuthStatus</a> for a list of expected values. </p></h3>
<h3><h3><a name="IncomingMessage">IncomingMessage</a> ( i )</h3><p><i>Description:</i> Sent, when a new message has been received and stored on the SIM card. </p><h4>Parameters</h4><i>i: index</i><p>The storage index of the new message. </p></h3>

    <hr/>
    <small>
    | Specified 2008-2012 by the <a href="http://www.freesmartphone.org">Freesmartphone.org</a> team. | Join us and discuss further drafts smartphones-standards (at) linuxtogo (dot) org
    </small>
    <hr/>
    </body>
</html>

